#include "PPView.h"
#include "Preferences.h"

//------------------------------------------------------------------------------

const char* eqs[10] = {
	"31", "72", "125", "250", "500", "1k", "2k", "4k", "8k", "16k"
};

//------------------------------------------------------------------------------

PPView::PPView(BRect frame, const char* name, uint32 resizingMode, uint32 flags)
	: BView(frame, name, resizingMode, flags)
{

}

PPView::~PPView()
{

}

void PPView::SetSliderLabel(int band)
{
	fBands[band]->SetLabel(eqs[band]);
}

#define kNumBands 10
#define kSliderSeparation 25

void PPView::AttachedToWindow()
{
	BRect R  = Bounds();
	R.left  += 5;
	R.right = R.left + 30;
	R.top += 10;
	R.bottom -= 10;

	BMessage* msg;

	for (int i = 0 ; i < kNumBands; i++)
	{
		msg = new BMessage(kSLIDER_CHANGE);
		msg->AddInt8("band_id", i);

		fBands[i] = new BSlider(R, "", "", msg, -99, 99,
								B_VERTICAL, B_BLOCK_THUMB,
								B_FOLLOW_TOP_BOTTOM
					);

		fBands[i]->SetTarget(this);
		fBands[i]->SetKeyIncrementValue(9);
		fBands[i]->SetHashMarks(B_HASH_MARKS_BOTH);
		fBands[i]->SetHashMarkCount(3);
		fBands[i]->SetBarThickness(1);

		fBands[i]->SetValue(ThePrefs.Gain(i));

		SetSliderLabel(i);
		AddChild(fBands[i]);

		R.left += kSliderSeparation;
		R.right = R.left + 30;
	}
}

void PPView::UpdateControls()
{

}

void PPView::MessageReceived(BMessage* msg)
{
	switch (msg->what)
	{
		case kSLIDER_CHANGE:
		{
			uint8 band = msg->FindInt8("band_id");
			ThePrefs.SetGain(band, fBands[band]->Value());
		}

   		default:
			BView::MessageReceived(msg);
		break;
	}
}
